#include "Explorer.h"

#include <algorithm>
#include <cmath>
#include <iostream>



void NeighborhoodExplorer::MakeMove(Coloring& coloring, const Move& rc) 
{
  if (rc.type == 1) 
    {
      //one-ex
      Color old_col;
      Vertex node = rc.seq[0];
      old_col = coloring.col[node];
      coloring.col[node] = rc.seq[1];
      p_sm->updateDeltaDataOneEx(coloring, rc.seq[0], old_col, rc.seq[1]);
      coloring.fitness += rc.delta;	  
      if (coloring.fitness != 0)
	coloring.feasible = false;
      else
	coloring.feasible = true;
    }
}



// random move builder
void OneExExplorer::RandomMove(const Coloring& coloring, Move& rc) 
{
  rc.seq.clear();
  rc.seq.resize(2);
  const Graph &g = *p_in; // g is an alias for the input Graph
  Vertex v;
  rc.type = 1;
  v = rc.seq[0] = rg->ran0N(g.Vertices()-1);
  while (coloring.conflicts[rc.seq[0]]==0)
    {
      rc.seq[0] = (rc.seq[0] + 1) % g.Vertices();
      if (rc.seq[0] == v)
	break;
    }
  if (rc.seq[0] == v && coloring.conflicts[rc.seq[0]]==0)
    {
      std::cerr << "Could not find any neighbor" << endl;
      std::cerr << "But the Conflict list has size: " 
		<< coloring.conflicts_set.size() << endl;
      cerr << coloring;
      assert(false);
    }

  do
    rc.seq[1] = (Color)rg->ran0N((coloring.CurrColors()-1));
  while (rc.seq[1] == (Vertex) coloring.col[rc.seq[0]]);
  rc.seq.push_back(coloring.col[rc.seq[0]]);
} 



// compute the next move in the exploration of the neighborhood
void OneExExplorer::NextMove(const Coloring& coloring, Move& rc) 
{    
  rc.seq.clear();
  rc.seq.resize(2);
  const Graph &g = *p_in; // g is an alias for the input Graph

  Color old_col = coloring.col[rc.seq[0]];

  rc.seq[1] = (rc.seq[1] + 1) % coloring.CurrColors();  


  // try the next conflicting node skipping the trivial move (i.e. nc = oc)
  if (rc.seq[1] == (Vertex) old_col) 
    { 
      do
	rc.seq[0] = (rc.seq[0] + 1) % g.Vertices();
      while (coloring.conflicts[rc.seq[0]] > 0);
      rc.seq[1] = (coloring.col[rc.seq[0]] + 1) % coloring.CurrColors();
    }
  rc.delta = Delta(coloring,rc);
  //rc.seq.push_back(coloring.col[rc.seq[0]]);
}

void OneExExplorer::BestMove(const Coloring &st, Move& mv)
{    


}

