#ifndef EXPLORER_H
#define EXPLORER_H
#include <vector>
#include "Utilities.h"
#include "Input.h"
#include "Control.h"
#include "Random.h"
#include "Solution.h"
#include "SolutionManager.h"

using namespace std;

class NeighborhoodExplorer
{
 public:       
    NeighborhoodExplorer(SolutionManager* sm,  Random *rnd, Graph* pin = NULL) 
      {p_sm = sm; p_in = pin; rg = rnd;}
    NeighborhoodExplorer(const NeighborhoodExplorer* ne)
    { p_sm = ne->p_sm; p_in = ne->p_in; rg = ne->rg;}
    /** Virtual destructor. */
    virtual ~NeighborhoodExplorer() {};
    
    virtual fvalue Delta(const Coloring& st,const Move& mv) const {return 0;};
    virtual void MakeMove(Coloring&, const Move&);

    virtual void RandomMove(const Coloring&, Move&) {};
    virtual void NextMove(const Coloring&, Move&) {};
    virtual void BestMove(const Coloring &st, Move& mv) {};
  protected:
    SolutionManager* p_sm; /**< A pointer to the attached 
					state manager. */
    Graph* p_in; /**< A pointer to the input object. */
    Random *rg;
};




/*------------------------------------------------------------
---------------- ONE-EX ----------------------------------------
------------------------------------------------------------*/

class OneExExplorer:public NeighborhoodExplorer
{
 public:
  OneExExplorer(SolutionManager* sm, Random *rnd, 
		   Graph* pin = NULL):
    NeighborhoodExplorer(sm,rnd,pin) {};
  OneExExplorer(const NeighborhoodExplorer* ne):
     NeighborhoodExplorer(ne) {};
  /** Virtual destructor. */
  virtual ~OneExExplorer() {};

  void RandomMove(const Coloring&, Move&);
  void NextMove(const Coloring&, Move&);
  void BestMove(const Coloring &st, Move& mv);

  inline fvalue Delta(const Coloring& st,const Move& mv) const
  {
  
  }
  
};



#endif





