#ifndef SOLUTION_H
#define SOLUTION_H
#include <vector>
#include "Input.h"
#include "Control.h"
#include "Random.h"

using namespace std;

// Object implemntaing the solution representation
class Coloring 
{
  friend std::ostream& operator<<(std::ostream&, const Coloring&);
 public:   
  Coloring(Random* rnd, Graph* pin);  
  Coloring() : p_in(0), rg(0) {};
  virtual ~Coloring() {};
  Coloring(const Coloring &);

  void SetInput(Graph* pin);
  void SetColors(Color num_col);
  const Color CurrColors() const {return k;};
  Coloring& operator=(const Coloring &a);
  bool operator==(const Coloring &a);

  inline fvalue& AdjColor(const Vertex& v, const Color& c) 
    {
      return adj_x_color[v*k+c];
    }

  inline const fvalue &AdjColor(const Vertex& v, const Color& c) const 
    {
      return adj_x_color[v*k+c];
    }

  ColorMap col;  // the map between nodes of the graphs and colors
  fvalue fitness;
 
  vector<Vertex> conflicts; // the set of conflicting nodes
  VertexSet conflicts_set;    
  vector<fvalue> adj_x_color;
  bool feasible;
  Color k; // the actual number of colors used 
protected:
  Graph *p_in; 
  Random* rg;
};




// Object representing a move 
class Move
{
 public:
  friend std::ostream& operator<<(std::ostream&, const Move&);
  Move();
  Move(const Move &a);
  Move& operator=(const Move &a);
  bool operator==(const Move &a);
  bool operator<(const Move &a) const {return seq[0]<a.seq[0];};
  vector<Vertex> seq;
  unsigned short int type; 
  fvalue delta;
};




#endif
