#ifndef SOLUTIONMANAGER_H
#define SOLUTIONMANAGER_H
#include <vector>
#include "Input.h"
#include "Control.h"
#include "Random.h"
#include "Solution.h"

using namespace std;

class SolutionManager
{
 public:
  SolutionManager(Random *rnd, Graph* pin,Control *ctrl);
  virtual ~SolutionManager() {};
  virtual fvalue computeFitness(Coloring &ass);
  void updateColoringData(Coloring &ass) const; 
  void updateDeltaDataOneEx(Coloring &ass, Vertex var, 
			    Color old_col, Color new_col);
  void randomAssignment(Coloring&, Color num_col);
  void constructiveGreedy(Coloring &ass);  

  void decrease_colors(Coloring &ass);

 protected:
  void SetInput(Graph* pin) { p_in = pin; }
  Graph *p_in;
  Random* rg;
  Control *p_ctrl;  
}; 





#endif
